var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Reduxable = function () {
  function Reduxable() {
    _classCallCheck(this, Reduxable);
  }

  Reduxable.setStore = function setStore(store) {
    this._store = store;
  };

  Reduxable.prototype.setScope = function setScope(scope) {
    this._scope = scope;
  };

  Reduxable.prototype.dispatch = function dispatch() {
    this.constructor._store.dispatch(arguments);
  };

  Reduxable.prototype.getState = function getState() {
    if (!this.constructor._store) {
      return this._localState || this.initialState;
    }

    var state = this.constructor._store.getState();
    if (!this._scope) {
      return state;
    }

    return this._scope.split('.').reduce(function (object, scopeKey) {
      return object[scopeKey];
    }, state);
  };

  Reduxable.prototype.getReducer = function getReducer() {
    var _this = this;

    return function () {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.initialState;
      var _ref = arguments[1];
      var type = _ref.type,
          scope = _ref.scope,
          payload = _ref.payload;

      if (scope !== _this._scope) {
        return state;
      }

      var method = _this.reducers[type];

      if (method) {
        var newState = method(state, payload);
        if (typeof state === 'object' && state === newState) {
          throw new Error('Reducer should never return the same `state` object');
        }
        return newState;
      }

      return state;
    };
  };

  _createClass(Reduxable, [{
    key: 'actions',
    get: function get() {
      var _this2 = this;

      if (!this._actions) {
        this._actions = {};

        var _loop = function _loop(reducerName) {
          if (_this2.reducers.hasOwnProperty(reducerName)) {
            _this2._actions[reducerName] = function (payload) {
              return { payload: payload, type: reducerName, scope: _this2._scope };
            };
          }
        };

        for (var reducerName in this.reducers) {
          _loop(reducerName);
        }
      }

      return this._actions;
    }
  }, {
    key: 'dispatchers',
    get: function get() {
      var _this3 = this;

      if (!this._boundedActions) {
        (function () {
          _this3._boundedActions = {};
          var dispatch = _this3.constructor._store ? _this3.constructor._store.dispatch : null;

          var _loop2 = function _loop2(reducerName) {
            if (_this3.reducers.hasOwnProperty(reducerName)) {
              _this3._boundedActions[reducerName] = dispatch ? function (payload) {
                return dispatch({ payload: payload, type: reducerName, scope: _this3._scope });
              } : function (payload) {
                return _this3._localState = _this3.reducers[reducerName](_this3.getState(), payload);
              };
            }
          };

          for (var reducerName in _this3.reducers) {
            _loop2(reducerName);
          }
        })();
      }

      return this._boundedActions;
    }
  }]);

  return Reduxable;
}();

export default Reduxable;